package de.nplusc.izc.tools.baseTools;

import de.nplusc.izc.tools.IOtools.FileTK;
import java.io.File;
import java.io.IOException;
import java.util.prefs.Preferences;
/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/**
 * Various detectuon routines
 * @author LH
 */
public class Detectors
{
    //@SuppressWarnings("empty-statement")
    
    
    /**
     * Detecs the OS Family and architecture
     * @return {OSFamily,Architecture}
     */
    public static String[] getSystemClassification()
    {
        String operatingSystemInternal = System.getProperty("os.name");
        String osname = "VOID";
        String osarchinternal = System.getProperty("os.arch");
        String osarch = "VOID";
        switch(operatingSystemInternal)
        {
            case "Linux":
                osname="Linux";
                break;
            case "Windows":
                osname="Windows";
                break;
        }
        switch(osarchinternal)
        {
            case "i386":
            case "i486":
            case "i586":
            case "i686":
            case "x86":
                osarch= "x86";
                break;
            case "x86_64":
            case "amd64":
                osarch = "x64";
                break;
        }
        return new String[]{osname,osarch};
    }
    
    
    /**
     * Checks whether OS is windows 8
     * @return True when win8 got detected
     */
    public static boolean detectIsWin8()
    {
        boolean ret = false;

        return FileTK.checkDirExist("C:\\Users\\Default\\appdata\\Local\\Microsoft\\windows\\WinX");
        /*
         String[] cnt = FileTK.getDirectoryContent("C:\\Users\\Default\\appdata\\Local\\Microsoft\\windows\\WinX");
         try
         {
         String s = cnt[0];
         }
         catch(Exception e){}*/
        //if(System.getProperty("os.name").equals("Windows 8"))
        //        {
        //            ret = true;
        //        }
        // return ret;

    }
    
    
    /**
     * Detecs if a 64bit windows7 got used
     * @return true on 64bit win7 or win8
     */
    public static boolean detect64bitWinon7and8()
    {
        return FileTK.checkDirExist("Program files (x86)");
    }

    
    /**
     * Detects if PRogram runs on WIndows XPlode
     * @return true if WinXP
     */
    public static boolean detectWInXP()
    {
        return FileTK.checkDirExist("C:\\WINDOWS\\Help\\Tours");
    }
    
    /**
     * Detects Existence of win7
     * @return true on win7
     */
    public static boolean detectWin7()
    {
        return FileTK.checkDirExist("C:\\Users") && !detectIsWin8();//Users gibts bei 7 und 8 deshalb die 2. bedingung
    }
    
    /**
     * Detecs whether program runs as Admin on windows
     * @return True when admin-rights are existing
     */
    public static boolean detectisAdmin()
    {
        ////neuer dirty hack
            Preferences prefs = Preferences.systemRoot();
    try{
        prefs.put("foo", "bar"); // SecurityException on Windows
        prefs.remove("foo");
        prefs.flush(); // BackingStoreException on Linux
        return true;
    }catch(Exception e){
        return false;
    }
        
        
        ////HACKALERT.... auskommentierter weg ging nicht muss ne eigenheit von WIndows ausnutzen auf C:\adminrechte zu verlangen
       /* try{
           File f =  new File("C:\\temp.dat");
           f.createNewFile();
           f.delete();
            
        }
        catch(IOException e)
        {
            return false;
        }
        return true;*/
        
        /*
        String groups[] = (new com.sun.security.auth.module.NTSystem()).getGroupIDs();
        for (String group : groups)
        {
            Tools.DebugHelperPrint("grp..."+group, true, "Toolkit.enableFinerDebug");
            if (group.equals("S-1-5-32-544"))
            {
                Tools.DebugHelperPrint("ADM", true, "Toolkit.enableFinerDebug");
                return true;
            }
        }
        return false;*/
    }

    private Detectors()
    {
    }
}
