/*
 * Copyright (C) 2014 iZc <nplusc.de>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
package de.nplusc.izc.izstreamer;

import com.sun.jna.Native;
import com.sun.jna.NativeLibrary;
import de.nplusc.izc.tools.IOtools.FileTK;
import de.nplusc.izc.tools.IOtools.LogStream;
import de.nplusc.izc.tools.IOtools.ZipFileHandler;
import de.nplusc.izc.tools.IOtools.iZformats.IZpackage;
import de.nplusc.izc.tools.baseTools.Messagers;
import de.nplusc.izc.tools.baseTools.Tools;
import java.io.BufferedOutputStream;
import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.PrintStream;
import java.net.MalformedURLException;
import java.net.URL;
import java.util.prefs.Preferences;
import org.apache.commons.io.FileUtils;
import uk.co.caprica.vlcj.binding.LibVlc;
import uk.co.caprica.vlcj.runtime.RuntimeUtil;

/**
 *
 * @author LH
 */
public class iZstreamer
{
    public static final int width=600;
    public static int height=400;
    public static final String jpath = new File(Player.class.getProtectionDomain().getCodeSource().getLocation().getPath()).getParent();
    public static void main(String[] args)
    {
        
        
        
        
        
        if (args.length > 0 && args[0].equals("--mkdist"))
        {
            
            
            
            
            
            
            Preferences.userRoot().put("Toolkit.enableCoreDebug", true + "");
            Preferences.userRoot().put("Toolkit.enableFinerDebug", true + "");

            
            System.out.println(jpath);
            try
            {
                new File(jpath + File.separator + "portableApp").createNewFile(); //erzeuge markerFile für portableMode des iZpacks
            }
            catch (IOException ex)
            {
                ex.printStackTrace();
            }
            FileTK.writeFile("@echo off\n"
                    + "set bindir=%~dp0\n"
                    + "cd %bindir%\n"
                    + "start javaw -jar -Xmx128M %bindir%\\iZStreamer.jar --appsource #sfxjar#\n"
                    + "REM DUMMYDUMMYDUMMYDUMMY",//<<<<HACK!
                    jpath + File.separator + "params.sfx");
            new File(jpath + "release.jar").delete();//alte jar ausm weg räumen falls nicht schon geschehen
            String apath = jpath + File.separator + "iZstreamerStandalone.jar";
            IZpackage.wrapArchive(apath, jpath);
            System.out.println("zippern");
            System.out.println(apath);
            if (args.length == 0)
            {
                Tools.runCmdStreamable(null, System.out, true, "zip", "-A", apath);//sfxen
            }
            System.out.println("zipped");
            System.exit(0);
            //sfx-jar mus unloaded sein damit selfpatch geht
        }
        else
        {
            if (args.length > 1)
            {
                if (args[0].equals("--appsource"))
                {

                    try
                    {

                        /*System.out.println("lfe");
                        PrintStream psOut = new LogStream(
                                new BufferedOutputStream(new FileOutputStream(
                                                new File(args[1]+".log"))), true);
                        System.setOut(psOut);
                        PrintStream psOut2 = new LogStream(
                                new BufferedOutputStream(new FileOutputStream(
                                                 new File(args[1]+"error.log"))), true);
                        System.setErr(psOut2);*/
                        ZipFileHandler ex;


                        String bitness = System.getProperty("os.arch");
                        String v_url = "http://nplusc.de/izstream/iZstream-vlc-" + bitness + "-win.zip";
                        String v_dlp = new File(Player.class.getProtectionDomain().
                                getCodeSource().getLocation().getPath()).getParent() + "\\vlc.zip";

                        String versionurl = "http://nplusc.de/izstream/iZstream-vlc.version";
                        String v_dlvp = new File(Player.class.getProtectionDomain().
                                getCodeSource().getLocation().getPath()).getParent() + "\\vlc_new.version";
                        String v_compareTo = new File(Player.class.getProtectionDomain().
                                getCodeSource().getLocation().getPath()).getParent() + "\\vlc.version";
                        FileUtils.copyURLToFile(new URL(versionurl), new File(v_dlvp));
                        new File(v_compareTo).createNewFile();
                        Thread.sleep(1000);
                        System.out.println("v_dlvp"+v_dlvp);
                        System.out.println("v_compareTo"+v_compareTo);
                        boolean redl = !FileUtils.contentEquals(new File(v_dlvp), new File(v_compareTo));
                        if (redl)
                        {
                            //checkversion
                            org.apache.commons.io.FileUtils.copyURLToFile(new URL(v_url), new File(v_dlp));
                            ex = new ZipFileHandler(v_dlp);
                            ex.extractAllToDiskWithMonitoringProgressbar(FileTK.getFilePath(v_dlp), null);
                            ex.unload();
                            FileUtils.forceDelete(new File(v_compareTo));//SO GEHTS RICHTIG!
                            FileUtils.copyFile(new File(v_dlvp),new File(v_compareTo));
                            FileUtils.forceDelete(new File(v_dlp));
                            FileUtils.forceDelete(new File(v_dlvp));
                            IZpackage.wrapArchive(args[1], FileTK.getFilePath(v_dlp));//selfmerge
                        }
                        else
                        {
                            FileUtils.forceDelete(new File(v_dlvp));
                        }
                        for (int i = 0; i < 2; i++)
                        {
                            try
                            {
                                String lpath = FileTK.getFilePath(Player.class.getProtectionDomain().getCodeSource().getLocation().getPath());
                                System.out.println("lpath" + lpath);
                                NativeLibrary.addSearchPath(
                                        RuntimeUtil.getLibVlcLibraryName(), lpath);
                                Native.loadLibrary(RuntimeUtil.getLibVlcLibraryName(), LibVlc.class);
                                i = 3;//breakt die schleife bei success
                                Player.main(null);
                                return;
                            }
                            catch (UnsatisfiedLinkError lickme)//sollte man nicht aber so erkenn ich ob die lib da ist :P
                            {
                                lickme.printStackTrace();
                                if (i == 0)
                                {

                                    try
                                    {
                                        org.apache.commons.io.FileUtils.copyURLToFile(new URL(v_url), new File(v_dlp));
                                        ex = new ZipFileHandler(v_dlp);
                                        ex.extractAllToDiskWithMonitoringProgressbar(FileTK.getFilePath(v_dlp), null);
                                        ex.unload();
                                        FileUtils.forceDelete(new File(v_dlp));
                                    }
                                    catch (IOException exe)
                                    {
                                        exe.printStackTrace();
                                    }
                                    IZpackage.wrapArchive(args[1], FileTK.getFilePath(v_dlp));
                                }
                                else//FUUU
                                {
                                    Messagers.SingleLineMsg("Fehler beim laden der Komponenten", "Verdammt");
                                    System.exit(0xdeadbeef);
                                }
                            }
                        }
                    }
                    catch (MalformedURLException ex)
                    {
                        ex.printStackTrace();
                    }
                    catch (IOException ex)
                    {
                        ex.printStackTrace();
                    }
                    catch (InterruptedException ex)
                    {
                        ex.printStackTrace();
                    }
                }
            }
            //System.out.println(Player.class.getProtectionDomain().getCodeSource().getLocation().getPath());
            //System.out.println(new File("/D:/src/zu/test/release.jar").length());
            // 
        }
    }//5ßx schritte
    
    //Now playing: Track name should be here"
    public static final int[] magic=new int[]{14,15,23,100    ,16,13,1,25,9,14,7,100,100
                    ,20,18,1,3,11,100,    14,1,13,5,100          ,19,8,15,21,13,4,100,   
                    2,5,100,   8,5,18,5,
                    
                    0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};
                    //15 16  20  9 13 21 19 100 16 18 9 13 5
                    //ABCDE FGHIJ KLMNO PQRST UVWXY Z
            
}
